diff --git a/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java b/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java
index 8ec0ff7c7..26008562e 100644
--- a/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java
+++ b/src/main/java/net/minecraft/core/net/packet/Packet23VehicleSpawn.java
@@ -1,124 +1,129 @@
 package net.minecraft.core.net.packet;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.projectile.EntityArrow;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.handler.NetHandler;
+import net.minecraft.core.util.helper.MathHelper;
 
-import java.io.*;
-
-// Referenced classes of package net.minecraft.src:
-//            Packet, NetHandler
-
-public class Packet23VehicleSpawn extends Packet
-{
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
 
-    public Packet23VehicleSpawn()
-    {
-    }
-    
-    public Packet23VehicleSpawn(Entity entity, int id)
+public class Packet23VehicleSpawn extends Packet {
+    public int entityId;
+    public int xPosition;
+    public int yPosition;
+    public int zPosition;
+    public float pitch;
+    public float yaw;
+    public boolean hasVelocity = false;
+    public short xVelocity = 0;
+    public short yVelocity = 0;
+    public short zVelocity = 0;
+    public short type = -1;
+    public int ownerId = -1;
+    public int metaData = -1;
+    public Packet23VehicleSpawn() {}
+    public Packet23VehicleSpawn(Entity entity)
     {
-        this(entity, id, 0);
+        this(entity, -1, -1, null, null, null);
     }
-    
-    public Packet23VehicleSpawn(Entity entity, int type, int id)
-    {
-        entityId = entity.id;
-        xPosition = MathHelper.floor_double(entity.x * 32D);
-        yPosition = MathHelper.floor_double(entity.y * 32D);
-        zPosition = MathHelper.floor_double(entity.z * 32D);
-        pitch = entity.xRot;
-        yaw = entity.yRot;
-        this.type = type;
-        ownerId = id;
-        if(id > 0)
-        {
-            double d = entity.xd;
-            double d1 = entity.yd;
-            double d2 = entity.zd;
-            double d3 = 3.9D;
-            if(d < -d3)
-            {
-                d = -d3;
-            }
-            if(d1 < -d3)
-            {
-                d1 = -d3;
-            }
-            if(d2 < -d3)
-            {
-                d2 = -d3;
-            }
-            if(d > d3)
-            {
-                d = d3;
-            }
-            if(d1 > d3)
-            {
-                d1 = d3;
-            }
-            if(d2 > d3)
-            {
-                d2 = d3;
-            }
-            xVelocity = (int)(d * 8000D);
-            yVelocity = (int)(d1 * 8000D);
-            zVelocity = (int)(d2 * 8000D);
-        }
-        if(entity instanceof EntityArrow){
-            arrowType = ((EntityArrow) entity).getArrowType();
+    public Packet23VehicleSpawn(Entity entity, int metaData){ this(entity, metaData, -1, null, null, null); }
+    public Packet23VehicleSpawn(Entity entity, int metaData, int ownerId){ this(entity, metaData, ownerId, null, null, null); }
+    public Packet23VehicleSpawn(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity) {
+        this.entityId = entity.id;
+        this.xPosition = MathHelper.floor_double(entity.x * 32D);
+        this.yPosition = MathHelper.floor_double(entity.y * 32D);
+        this.zPosition = MathHelper.floor_double(entity.z * 32D);
+        this.pitch = entity.xRot;
+        this.yaw = entity.yRot;
+        this.metaData = metaData;
+        this.ownerId = ownerId;
+        if (xVelocity != null || yVelocity != null || zVelocity != null){
+            this.xVelocity = (short) ((xVelocity == null ? 0 : xVelocity) * 8000D);
+            this.yVelocity = (short) ((yVelocity == null ? 0 : yVelocity) * 8000D);
+            this.zVelocity = (short) ((zVelocity == null ? 0 : zVelocity) * 8000D);
+            this.hasVelocity = true;
+        } else {
+            this.hasVelocity = false;
         }
     }
+    public Packet23VehicleSpawn setType(int type){
+        this.type = (short) type;
+        return this;
+    }
 
 
     @Override
-	public void readPacketData(DataInputStream dis)
-        throws IOException
-    {
+	public void readPacketData(DataInputStream dis) throws IOException {
         entityId = dis.readInt();
-        type = dis.readByte();
+        type = dis.readShort();
         xPosition = dis.readInt();
         yPosition = dis.readInt();
         zPosition = dis.readInt();
         pitch = dis.readFloat();
         yaw = dis.readFloat();
-        ownerId = dis.readInt();
-        if(ownerId > 0)
-        {
+        byte optionals = dis.readByte();
+
+        if (hasVelocity(optionals)){
             xVelocity = dis.readShort();
             yVelocity = dis.readShort();
             zVelocity = dis.readShort();
+            hasVelocity = true;
+        }
+        if (hasOwner(optionals)){
+            ownerId = dis.readInt();
         }
-        if(type == 60)
-        {
-            arrowType = dis.readInt();
+        if (hasMeta(optionals)){
+            metaData = dis.readInt();
         }
     }
 
     @Override
-	public void writePacketData(DataOutputStream dos)
-        throws IOException
-    {
+	public void writePacketData(DataOutputStream dos) throws IOException {
         dos.writeInt(entityId);
-        dos.writeByte(type);
+        dos.writeShort(type);
         dos.writeInt(xPosition);
         dos.writeInt(yPosition);
         dos.writeInt(zPosition);
         dos.writeFloat(pitch);
         dos.writeFloat(yaw);
-        dos.writeInt(ownerId);
-        if(ownerId > 0)
-        {
+        byte optionals = makeOptionalsByte(hasVelocity, ownerId >= 0, metaData >= 0);
+        dos.writeByte(optionals);
+
+        if(hasVelocity(optionals)) {
             dos.writeShort(xVelocity);
             dos.writeShort(yVelocity);
             dos.writeShort(zVelocity);
         }
-        if(type == 60|| type == 73)
-        {
-            dos.writeInt(arrowType);
+        if(hasOwner(optionals)) {
+            dos.writeInt(ownerId);
+        }
+        if(hasMeta(optionals)) {
+            dos.writeInt(metaData);
         }
     }
+    public boolean hasOwner(byte val){
+        return (val &   0b1) != 0;
+    }
+    public boolean hasMeta(byte val){
+        return (val &  0b10) != 0;
+    }
+    public boolean hasVelocity(byte val){
+        return (val & 0b100) != 0;
+    }
+    public byte makeOptionalsByte(boolean hasVelocity, boolean hasOwner, boolean hasMeta){
+        byte val = 0;
+        if (hasOwner){
+            val |=   0b1;
+        }
+        if (hasMeta){
+            val |=  0b10;
+        }
+        if (hasVelocity){
+            val |= 0b100;
+        }
+        return val;
+    }
 
     @Override
 	public void processPacket(NetHandler netHandler)
@@ -131,17 +136,4 @@ public class Packet23VehicleSpawn extends Packet
     {
         return 21 + ownerId <= 0 ? 0 : 6;
     }
-
-    public int entityId;
-    public int xPosition;
-    public int yPosition;
-    public int zPosition;
-    public float pitch;
-    public float yaw;
-    public int xVelocity;
-    public int yVelocity;
-    public int zVelocity;
-    public int type;
-    public int ownerId;
-    public int arrowType;
 }
diff --git a/src/main/java/net/minecraft/core/world/LevelListener.java b/src/main/java/net/minecraft/core/world/LevelListener.java
index 0a509079a..03d381c3f 100644
--- a/src/main/java/net/minecraft/core/world/LevelListener.java
+++ b/src/main/java/net/minecraft/core/world/LevelListener.java
@@ -10,6 +10,16 @@ import net.minecraft.core.sound.SoundCategory;
 
 public interface LevelListener
 {
+    public static final int EVENT_DISPENSER_ITEM = 1000;
+    public static final int EVENT_DISPENSER_EMPTY = 1001;
+    public static final int EVENT_DISPENSER_PROJECTILE = 1002;
+    public static final int EVENT_DOOR_SOUND = 1003;
+    public static final int EVENT_DISPENSER_PARTICLES = 2000;
+    public static final int EVENT_BLOCK_BREAK = 2001;
+    public static final int EVENT_FIRE_EXTINGUISH = 1004;
+    public static final int EVENT_JUKEBOX_TOGGLE = 1005;
+    public static final int EVENT_PISTON_EXTEND = 1006;
+    public static final int EVENT_PISTON_RETRACT = 1007;
 
 	/**
 	 * Redraw block in singleplayer and send block change packet in multiplayer. <br>
diff --git a/src/main/java/net/minecraft/server/entity/EntityTracker.java b/src/main/java/net/minecraft/server/entity/EntityTracker.java
index e4229ae8e..2534a1d2f 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTracker.java
+++ b/src/main/java/net/minecraft/server/entity/EntityTracker.java
@@ -1,31 +1,26 @@
 package net.minecraft.server.entity;
 
-import java.util.*;
-
-import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.animal.EntityFireflyCluster;
-import net.minecraft.core.entity.animal.EntitySquid;
-import net.minecraft.core.entity.animal.IAnimal;
-import net.minecraft.server.entity.player.EntityPlayerMP;
-import net.minecraft.core.entity.projectile.*;
-import net.minecraft.core.entity.vehicle.EntityBoat;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
-import net.minecraft.server.MinecraftServer;
-import net.minecraft.core.world.pathfinder.IdHashMap;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.world.pathfinder.IdHashMap;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.EntityPlayerMP;
 
-// Referenced classes of package net.minecraft.src:
-//            MCHash, ServerConfigurationManager, EntityPlayerMP, EntityTrackerEntry, 
-//            EntityFish, EntityArrow, EntityFireball, EntitySnowball, 
-//            EntityEgg, EntityItem, EntityMinecart, EntityBoat, 
-//            EntitySquid, IAnimals, EntityTNTPrimed, EntityFallingSand, 
-//            EntityPainting, Entity, WorldServer, Packet
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Set;
 
-public class EntityTracker
-{
+public class EntityTracker {
+    public final Set<EntityTrackerEntry> trackedEntitySet;
+    public final IdHashMap<EntityTrackerEntry> trackedEntityHashTable;
+    public final MinecraftServer mcServer;
+    public final int maxTrackingDistanceThreshold;
+    public final int dimension;
 
-    public EntityTracker(MinecraftServer minecraftserver, int dimId)
-    {
+    public EntityTracker(MinecraftServer minecraftserver, int dimId) {
         trackedEntitySet = new HashSet<>();
         trackedEntityHashTable = new IdHashMap<>();
         mcServer = minecraftserver;
@@ -33,108 +28,27 @@ public class EntityTracker
         maxTrackingDistanceThreshold = minecraftserver.playerList.getMaxTrackingDistance();
     }
 
-    public void trackEntity(Entity entity)
-    {
-        if(entity instanceof EntityPlayerMP)
-        {
-            trackEntity(entity, 512, 2, false);
-            EntityPlayerMP entityplayermp = (EntityPlayerMP)entity;
-            Iterator<EntityTrackerEntry> iterator = trackedEntitySet.iterator();
-            do
-            {
-                if(!iterator.hasNext())
-                {
-                    break;
-                }
-                EntityTrackerEntry entitytrackerentry = iterator.next();
-                if(entitytrackerentry.trackedEntity != entityplayermp)
-                {
-                    entitytrackerentry.updatePlayerEntity(entityplayermp);
-                }
-            } while(true);
-        } else
-        if(entity instanceof EntityFireflyCluster)
-        {
-            trackEntity(entity, 160, 40, false);
-        } else
-        if(entity instanceof EntityBobber)
-        {
-            trackEntity(entity, 64, 5, true);
-        } else
-        if(entity instanceof EntityArrow)
-        {
-            trackEntity(entity, 64, 20, false);
-        } else
-        if(entity instanceof EntityCannonball)
-        {
-            trackEntity(entity, 64, 10, false);
-        } else
-        if(entity instanceof EntityFireball)
-        {
-            trackEntity(entity, 64, 10, false);
-        } else
-        if(entity instanceof EntitySnowball)
-        {
-            trackEntity(entity, 64, 10, true);
-        } else
-        if(entity instanceof EntityEgg)
-        {
-            trackEntity(entity, 64, 10, true);
-        } else
-        if(entity instanceof EntityPebble)
-        {
-            trackEntity(entity, 64, 10, true);
-        } else
-        if(entity instanceof EntityItem)
-        {
-            trackEntity(entity, 64, 20, true);
-        } else
-        if(entity instanceof EntityMinecart)
-        {
-            trackEntity(entity, 160, 1, true);
-        } else
-        if(entity instanceof EntityBoat)
-        {
-            trackEntity(entity, 160, 1, true);
-        } else
-        if(entity instanceof EntitySquid)
-        {
-            trackEntity(entity, 160, 3, true);
-        } else
-        if(entity instanceof IAnimal)
-        {
-            trackEntity(entity, 160, 3, false);
-        } else
-        if(entity instanceof EntityTNT)
-        {
-            trackEntity(entity, 160, 10, true);
-        } else
-        if(entity instanceof EntityFallingSand)
-        {
-            trackEntity(entity, 160, 20, true);
-        } else
-        if(entity instanceof EntityPainting)
-        {
-            trackEntity(entity, 160, 0x7fffffff, false);
+    public void trackEntity(Entity entity) {
+        ITrackedEntry<Entity> trackedConfig = NetEntityHandler.getTrackedEntry(entity);
+        if (trackedConfig != null){
+            EntityTrackerEntry trackerEntry = trackEntity(entity, trackedConfig.getTrackingDistance(), trackedConfig.getPacketDelay(), trackedConfig.sendMotionUpdates());
+            trackedConfig.onEntityTracked(this, trackerEntry, entity);
         }
     }
 
-    public void trackEntity(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates)
+    public EntityTrackerEntry trackEntity(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates)
     {
-        if(trackingDistance > maxTrackingDistanceThreshold)
-        {
+        if(trackingDistance > maxTrackingDistanceThreshold) {
             trackingDistance = maxTrackingDistanceThreshold;
         }
-        if(trackedEntityHashTable.containsItem(entity.id))
-        {
+        if(trackedEntityHashTable.containsItem(entity.id)) {
             throw new IllegalStateException("Entity is already tracked!");
-        } else
-        {
-            EntityTrackerEntry entitytrackerentry = new EntityTrackerEntry(entity, trackingDistance, packetDelay, shouldSendMotionUpdates);
-            trackedEntitySet.add(entitytrackerentry);
-            trackedEntityHashTable.add(entity.id, entitytrackerentry);
-            entitytrackerentry.updatePlayerEntities(mcServer.getDimensionWorld(dimension).players);
         }
+        EntityTrackerEntry trackerEntry = new EntityTrackerEntry(entity, trackingDistance, packetDelay, shouldSendMotionUpdates);
+        trackedEntitySet.add(trackerEntry);
+        trackedEntityHashTable.add(entity.id, trackerEntry);
+        trackerEntry.updatePlayerEntities(mcServer.getDimensionWorld(dimension).players);
+        return trackerEntry;
     }
 
     public void untrackEntity(Entity entity)
@@ -160,20 +74,12 @@ public class EntityTracker
     public void tick()
     {
         ArrayList<Entity> arraylist = new ArrayList<>();
-        Iterator<EntityTrackerEntry> iterator = trackedEntitySet.iterator();
-        do
-        {
-            if(!iterator.hasNext())
-            {
-                break;
-            }
-            EntityTrackerEntry entitytrackerentry = iterator.next();
+        for (EntityTrackerEntry entitytrackerentry : trackedEntitySet) {
             entitytrackerentry.tick(mcServer.getDimensionWorld(dimension).players);
-            if(entitytrackerentry.playerEntitiesUpdated && (entitytrackerentry.trackedEntity instanceof EntityPlayerMP))
-            {
+            if (entitytrackerentry.playerEntitiesUpdated && (entitytrackerentry.trackedEntity instanceof EntityPlayerMP)) {
                 arraylist.add(entitytrackerentry.trackedEntity);
             }
-        } while(true);
+        }
 label0:
         for(int i = 0; i < arraylist.size(); i++)
         {
@@ -222,10 +128,4 @@ label0:
         }
 
     }
-
-    private final Set<EntityTrackerEntry> trackedEntitySet;
-    private final IdHashMap<EntityTrackerEntry> trackedEntityHashTable;
-    private final MinecraftServer mcServer;
-    private final int maxTrackingDistanceThreshold;
-    private final int dimension;
 }
